module.exports.__fsLocationMap = [[1, 8, 3, 7], [1, 20, 3, 24], [1, 8, 3, 36], [2, 8, 4, 7], [2, 20, 4, 24], [2, 8, 4, 36], [4, 1, 5, 1], [4, 7, 5, 7], [4, 16, 5, 16], [4, 20, 5, 20], [6, 8, 6, 1], [6, 14, 6, 7], [7, 5, 7, 3], [7, 18, 7, 16], [7, 18, 8, 5], [7, 18, 8, 12], [8, 9, 9, 5], [8, 14, 9, 10], [8, 22, 9, 18], [8, 27, 9, 23], [8, 36, 9, 32], [9, 9, 10, 5], [9, 14, 10, 10], [9, 21, 10, 17], [9, 26, 10, 22], [9, 34, 10, 30], [10, 9, 11, 5], [10, 14, 11, 10], [10, 21, 11, 17], [11, 9, 12, 5], [11, 14, 12, 10], [11, 28, 12, 24], [13, 9, 13, 5], [13, 14, 13, 10], [13, 24, 13, 20], [13, 29, 13, 25], [13, 40, 13, 36], [14, 9, 14, 5], [14, 14, 14, 10], [14, 23, 14, 19], [14, 28, 14, 24], [14, 38, 14, 34], [16, 9, 15, 5], [16, 14, 15, 10], [16, 35, 15, 31], [26, 5, 25, 3], [27, 9, 27, 5], [27, 14, 27, 10], [27, 28, 27, 24], [28, 9, 28, 5], [28, 16, 28, 12], [35, 5, 36, 3], [36, 9, 37, 5], [36, 15, 37, 11], [36, 23, 37, 19], [36, 28, 37, 24], [37, 9, 38, 5], [37, 15, 38, 11], [37, 22, 38, 18], [37, 27, 38, 23], [39, 9, 39, 5], [39, 12, 39, 9], [39, 17, 39, 14], [40, 13, 40, 7], [40, 18, 40, 12], [40, 26, 40, 20], [40, 31, 40, 25], [42, 9, 42, 5], [42, 15, 42, 11], [42, 25, 42, 21], [42, 30, 42, 26], [42, 38, 42, 34], [42, 42, 42, 38], [42, 43, 42, 39], [43, 13, 43, 7], [43, 20, 43, 14], [43, 59, 43, 53], [44, 11, 44, 8], [44, 16, 44, 13], [46, 9, 45, 5], [46, 15, 45, 11], [46, 24, 45, 20], [46, 29, 45, 25], [46, 36, 45, 32], [46, 40, 45, 36], [46, 41, 45, 37], [47, 13, 46, 7], [47, 20, 46, 14], [47, 52, 46, 46], [50, 9, 48, 5], [50, 12, 48, 9], [50, 17, 48, 14], [51, 13, 49, 7], [51, 20, 49, 14], [51, 25, 49, 19], [51, 68, 49, 62], [51, 73, 49, 67], [53, 9, 51, 5], [53, 15, 51, 11], [53, 27, 51, 23], [53, 34, 51, 30], [53, 39, 51, 35], [55, 9, 52, 5], [55, 15, 52, 11], [55, 22, 52, 18], [58, 97, 54, 18], [59, 134, 55, 11], [60, 165, 56, 11], [63, 245, 59, 11], [68, 9, 62, 5], [68, 16, 62, 12], [6, 14, 68, 16], [6, 14, 68, 23]];
module.exports.__esModule = true;
const FirescriptRuntime = require('firescript-runtime').FirescriptRuntime;
const Server = require('./Server').Server;
const Logger = require('./Logger').Logger;
const logger = new Logger();
class Page {
  constructor (opts) {
    opts = opts || {};
    this.title = opts.title || 'Blank page';
    this.icon = opts.icon || null;
    this.tick = 0;
    this.pageContent = '';
    this.scripts = opts.scripts || [  ];
    this.styles = opts.styles || [  ];
    this.importFireIOClient = false;
  }

  /**
      * Set page content, overwrites existing content
      *
      * @method {html}
      * @param {str} pageContent
      * @returns Instance of Page
      */
  html (pageContent) {
    FirescriptRuntime.paramTyping(FirescriptRuntime.TYPE_STR, pageContent, 'pageContent');
    this.pageContent = pageContent;
    return this;
  }

  /**
      * Render page
      *
      * @returns Rendered page as html string
      */
  render () {
    const title = this.title;
    const body = this.pageContent;
    if (this.importFireIOClient) {
      this.scripts.push('/js/fireio-client.js');
    }
    const scripts = this.scripts.map((scriptPath) => {
      return `<script type="text/javascript" src="${scriptPath}"></script>`;
    }).join('\n');
    const styles = this.styles.map((stylePath) => {
      return `<link rel="Stylesheet" href="${stylePath}">`;
    });
    if (this.icon) {
      styles.push(`<link rel="icon" type="image/png" href="${this.icon}">`);
    }
    const stylesStr = styles.join('\n');
    const html = `<html>
    <head>
        <title>${title}</title>
        ${scripts}
        ${stylesStr}
    </head>
    <body>
        ${body}
    </body>
</html>`;
    return html;
  }
  // cmp (cmpTree)
  //     const cmp = new ComponentTree(cmpTree)
  //     this.pageContent = cmp.render()
}
module.exports.Page = Page;
